#include	"bmptype.h"

#include <stdio.h>
#include <alloc.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

#ifdef	__BETA__

#	if defined (__MSDOS__)
static char     thisVersion[]="1.2 Beta (DOS)";
#	elif defined (__OS2__)
static char     thisVersion[]="1.2 Beta (OS2)";
#	elif defined (__WIN32__)
static char     thisVersion[]="1.2 Beta (WIN32)";
#	endif

#else

#	if defined (__MSDOS__)
static char     thisVersion[]="1.2 (DOS)";
#	elif defined (__OS2__)
static char     thisVersion[]="1.2 (OS2)";
#	elif defined (__WIN32__)
static char     thisVersion[]="1.2 (WIN32)";
#	endif

#endif

extern	bmp_rgbquad_type	palette[256];

bmp_fileheader_type     bmp_hdr;
bmp_infoheader_type     bmp_inf;
bmp_rgbquad_type        bmp_pal;
char							sz_line[1024];


int main (int na, char **a)
{
	int	istat, ch, lastch;
	long	bmppos, imgpos;
	long	outcnt;
	long	imageSize;
	int	image_xsize;
	int 	image_ysize;
   int   i;
	char*	p;
   char* psz_imgFilename;
   char* psz_bmpFilename;
   int	b_stripHeading	=	1;

	FILE*	imgfile;
	FILE* bmpfile;

	image_xsize	=	512;
	image_ysize	=	256;

   psz_imgFilename	=	NULL;
   psz_bmpFilename	=	NULL;

   printf
	(	"\nIMG2BMP %s %s - Copyright (c) 2002 Marco Savegnago\n"
		"Raw 256 Gray Level Bitmap to Standard 256 Gray Level .BMP File Utility\n\n", thisVersion, __DATE__
   );

	if (na < 3)
	{
		puts(
			 "Usage: IMG2BMP [options] <IMGFILE> <BMPFILE>\n\n"
			 "Options are:\n\n"
          "  -S    = Skip heading garbage elimination\n"
			 "  -Hn   = Set Image Height (default = 256)\n"
			 "  -Wn   = Set Image Width (default = 512)\n"
			 );
		return(1);
	}

	/* Scan command line argument for the options */

	for(i=1;i<na;i++)
	{
		p=a[i];

		if(*p =='/' || *p=='-')
		{
			p++;
			switch(toupper(*p))
			{
				case 'H':
            	if (!*++p || !isdigit(*p))
               {
               	puts ("\nError: invalid height value specified\a\n");
                  exit(1);
					}

               image_ysize	=	atoi(p);
					break;
            case 'S':
            	b_stripHeading	=	0;
               break;

				case 'W':
            	if (!*++p || !isdigit(*p))
               {
               	puts ("\nError: invalid Width value specified\a\n");
                  exit(1);
					}

               image_xsize	=	atoi(p);
					break;

				default:
					break;
			}
		}
      else
      {
         if(psz_imgFilename==NULL)
         	psz_imgFilename=p;
         else
         	psz_bmpFilename=p;
      }
	}

	if(NULL==(imgfile = fopen(psz_imgFilename,"rb")))
   {
   	printf ("\nError: unable to open file %s for reading\a\n", psz_imgFilename);
      exit(3);
   }

	if(NULL==(bmpfile = fopen(psz_bmpFilename,"wb+")))
   {
   	printf ("\nError: unable to open file %s for writing\a\n", psz_imgFilename);
      exit(4);
   }

	/* set the bitmap info header */

	bmp_inf.biSize          = sizeof(bmp_infoheader_type);
	bmp_inf.biWidth         = image_xsize;
	bmp_inf.biHeight        = image_ysize;
	bmp_inf.biXpelsPerMeter = 0;
	bmp_inf.biYpelsPerMeter = 0;
	bmp_inf.biClrUsed       = 0;
	bmp_inf.biClrImportant  = 0;
	bmp_inf.biPlanes        = 1;
	bmp_inf.biCompression   = 0;

	bmp_inf.biBitCount  		= 8;

	bmp_inf.biSizeImage = (dword) image_xsize * (dword) image_ysize;

	/* set the file header info */

	bmp_hdr.bfType      	= 0x4D42;
	bmp_hdr.bfReserved1 	= 0;
	bmp_hdr.bfReserved2 	= 0;

   //	bmp_hdr.bfOffBits 	=	sizeof(bmp_fileheader_type) + sizeof(bmp_infoheader_type) + sizeof(bmp_rgbquad_type) * 256

	bmp_hdr.bfOffBits 	= 1078;

	bmp_hdr.bfSize = bmp_hdr.bfOffBits + bmp_inf.biSizeImage;

	/* write the headers and palette out */

	istat = fwrite(&bmp_hdr,sizeof(bmp_fileheader_type),1,bmpfile);

   bmppos	=	ftell(bmpfile);

   bmppos	=	bmppos;

	istat = fwrite(&bmp_inf,sizeof(bmp_infoheader_type),1,bmpfile);

   bmppos	=	ftell(bmpfile);

   bmppos	=	bmppos;

/*
	for (indx=0; indx<256; indx++)
   	istat =	fwrite(&palette[indx], sizeof(bmp_rgbquad_type), 1, bmpfile);
*/

   istat =	fwrite(&palette, sizeof(bmp_rgbquad_type) * 256, 1, bmpfile);

   bmppos	=	ftell(bmpfile);

   bmppos	=	bmppos;

	/* now encode and write the image data - .BMP goes from bottom to top */

	outcnt=0;

	imageSize = (long)image_xsize	* (long)image_ysize;

   bmppos	=	ftell(bmpfile);

   if(b_stripHeading)
   {

      printf("\nAnalizing file ... ");

      lastch	=	ch	=	0;

      imgpos	=	0;

      while(1)
      {
         ch	=	fgetc(imgfile);

         if(ch == '\n' && lastch	== '\r')
         {
            //	found a cr + lf
            imgpos	=	ftell(imgfile);
         }

         if(feof(imgfile))
            break;

         lastch	=	ch;
      }

      rewind(imgfile);

      if(imgpos)
      {
         printf(" Ok skip the first %d characters\n", imgpos);
         fseek(imgfile, imgpos, SEEK_SET);
      }
	}
/*
   bmppos	=	ftell(bmpfile);

   bmppos	=	bmppos;
*/
	while(1)
	{
		ch	=	fgetc(imgfile);

		if(feof(imgfile) || outcnt>=imageSize)
			break;

		fputc(ch, bmpfile);

		outcnt++;
	}

	while(outcnt<imageSize)
	{
		outcnt++;
		fputc(0, bmpfile);
	}

   puts("\nConversion completed.");


	fclose(imgfile);
	fclose(bmpfile);

	return 0;

} /* write_bmp_file */

